function[ y ] = preprocessCorrelation( s, varg )
    
    if(isempty(varg))
        if(s.coordinates ~= s.coordinatesPreProcess)
            s.coordinatesPreProcess = s.coordinates;
            k = ceil(s.percSampleCorrspace * s.effHeight * s.effWidth );
            a = reshape( s.dataFile, s.effHeight * s.effWidth,[] );
            b = datasample(a, k);
            r = correl_nonsquare(a', b');
            s.processedData = reshape(r, s.effHeight, s.effWidth, []);
        end
        y = s.processedData;
        
    else
        coor = varg{1};
        k = ceil(s.percSampleCorrspace * ( coor( 2 ) - coor( 1 ) + 1) * ( coor( 4 ) - coor( 3 ) + 1 ));

        y = h5read( s.dataFileName, '/data', [ coor(1), coor(3), 1 ], [ coor( 2 ) - coor( 1 ) + 1, coor( 4 ) - coor( 3 ) + 1, s.nFramesEff ] );

        a = reshape( y, ( coor( 2 ) - coor( 1 ) + 1) * ( coor( 4 ) - coor( 3 ) + 1 ),[] );
        b = datasample(a, k);
        r = correl_nonsquare(a', b');
        y = reshape(r, s.effHeight, s.effWidth, []);
    end
end

function [r] = correl_nonsquare(a, b)
    % Computes correlation matrix between columns of a and columns of b
    % Size(a,1) == size(b,1)
    % Output matrix has size size(a,2) x size(b,2)
    r = cov_nonsquare(a,b);
    drow = sqrt(var(a)); % sqrt first to avoid under/overflow
    dcol = sqrt(var(b));
    
    % set correl to zero if variance == 0 (to prevent nans)
    drow(drow==0) = 1;
    dcol(dcol==0) = 1;
    
    r = r ./ (drow' * dcol); %
    t = find(abs(r) > 1); r(t) = r(t)./abs(r(t));
end

function [x] = cov_nonsquare(a,b)
    m = size(a,1);
    ac = a - repmat(sum(a, 1), size(a,1), 1) ./ m;
    bc = b - repmat(sum(b, 1), size(b,1), 1) ./ m;
    
    if m > 1
        denom = m - 1;
    else
        denom = m;
    end
        
    x = ac' * bc ./ denom;
end
